-- fifo_cell
-- eine Zelle zum Aufbau von fifo
-- Uebung 4 Entwurf digitaler Systeme

library ieee;
use ieee.std_logic_1164.all;
library work;
use work.all;

entity fifo_cell is
	generic(width : natural := 8);
	port(
		clk : in std_logic; 
		clr_n : in std_logic;
		d_in_0 : in std_logic_vector(width-1 downto 0); 
		d_in_1 : in std_logic_vector(width-1 downto 0);
		sel : in std_logic; -- Auswahl zwischen in_0 und in_1
		ena : in std_logic; -- Enable 
		d_out : out std_logic_vector(width-1 downto 0) -- Ausgang
	);
end fifo_cell;

architecture struct of fifo_cell is
	signal d : std_logic_vector(width-1 downto 0);
begin

	Daten_Register: entity reg
		generic map(width)
		port map(
			d => d,
			q => d_out,
			clr_n => clr_n,
			clk => clk,
			ena => ena
		);

	Multiplexer: entity mux_2
		generic map(width)
		port map(
			in0 => d_in_0,
			in1 => d_in_1,
			sel => sel,
			o => d
			);	
			
end architecture struct;
